searchNodes=[{"doc":"StripJs is an Elixir module for stripping executable JavaScript from blocks of HTML and CSS, based on the &lt;a target=_blank href=&quot; https://github.com/philss/floki&quot;&gt;Floki&lt;/a&gt; parsing library. It handles: &lt;script&gt;...&lt;/script&gt; and &lt;script src=&quot;...&quot;&gt;&lt;/script&gt; tags Event handler attributes such as onclick=&quot;...&quot; javascript:... URLs in HTML and CSS CSS expression(...) directives HTML entity attacks (like &amp;lt;script&amp;gt; ) StripJs is production ready, and has sanitized over 1.5 billion payloads at Appcues. Installation Add strip_js to your application's mix.exs : def application do [ applications : [ :strip_js ] ] end def deps do [ { :strip_js , &quot;~&gt; \#{ StripJs.Mixfile . project ( ) [ :version ] } &quot; } ] end Usage clean_html/2 removes all JS vectors from an HTML string: iex&gt; html = &quot;&lt;button onclick= \\&quot; alert(&#39;pwnt&#39;) \\&quot; &gt;Hi!&lt;/button&gt;&quot; iex&gt; StripJs . clean_html ( html ) &quot;&lt;button&gt;Hi!&lt;/button&gt;&quot; clean_css/2 removes all JS vectors from a CSS string: iex&gt; css = &quot;body { background-image: url(&#39;javascript:alert()&#39;); }&quot; iex&gt; StripJs . clean_css ( css ) &quot;body { background-image: url(&#39;removed_by_strip_js:alert()&#39;); }&quot; StripJs relies on the Floki HTML parser library, which is built using Mochiweb by default. StripJs provides a clean_html_tree/1 function to strip JS from Floki.parse_fragment/1 - and :mochiweb_html.parse/1 - style HTML parse trees. Security StripJs blocks every JS injection vector known to the authors. It has survived four years in production, multiple professional penetration tests, and over a billion invocations with no known security issues. If you believe there are JS injection methods not covered by this library, please submit an issue with a test case! Bugs and Limitations The brokenness of invalid HTML may be amplified by clean_html/2 . In uncommon cases, innocent CSS which very closely resembles JS-injection techniques may be mangled by clean_css/2 . Authorship and License Copyright 2017-2021, Appcues, Inc. Project homepage: StripJs StripJs is released under the MIT License .","ref":"StripJs.html","title":"StripJs","type":"module"},{"doc":"Removes JS vectors from the given CSS string; i.e., the contents of a stylesheet or &lt;style&gt; tag. Does not HTML-escape its output. Care is taken to maintain valid CSS syntax. Example: iex&gt; css = &quot;tt { background-color: expression(&#39;alert()&#39;); }&quot; iex&gt; StripJs . clean_css ( css ) &quot;tt { background-color: removed_by_strip_js(&#39;alert()&#39;); }&quot; Warning: this step is performed using regexes, not a parser, so it is possible for innocent CSS containing either of the strings javascript: or expression( to be mangled.","ref":"StripJs.html#clean_css/2","title":"StripJs.clean_css/2","type":"function"},{"doc":"Removes JS vectors from the given HTML string. All non-tag text and tag attribute values will be HTML-escaped, except for the contents of &lt;style&gt; tags, which are passed through clean_css/2 . Even if the input HTML contained no JS, the output of clean_html/2 is not guaranteed to match its input byte-for-byte. Examples: iex&gt; StripJs . clean_html ( &quot;&lt;button onclick= \\&quot; alert(&#39;phear&#39;); \\&quot; &gt;Click here&lt;/button&gt;&quot; ) &quot;&lt;button&gt;Click here&lt;/button&gt;&quot; iex&gt; StripJs . clean_html ( &quot;&lt;script&gt; console.log(&#39;oh heck&#39;); &lt;/script&gt;&quot; ) &quot;&quot; iex&gt; StripJs . clean_html ( &quot;&amp;lt;script&amp;gt; console.log(&#39;oh heck&#39;); &amp;lt;/script&amp;gt;&quot; ) &quot;&amp;lt;script&amp;gt; console.log(&#39;oh heck&#39;); &amp;lt;/script&amp;gt;&quot; ## HTML entity attack didn&#39;t work","ref":"StripJs.html#clean_html/2","title":"StripJs.clean_html/2","type":"function"},{"doc":"Removes JS vectors from the given Floki / Mochiweb -style HTML tree ( html_tree/0 ). All attribute values and tag bodies except embedded stylesheets will be HTML-escaped.","ref":"StripJs.html#clean_html_tree/2","title":"StripJs.clean_html_tree/2","type":"function"},{"doc":"","ref":"StripJs.html#t:html_attr/0","title":"StripJs.html_attr/0","type":"type"},{"doc":"","ref":"StripJs.html#t:html_node/0","title":"StripJs.html_node/0","type":"type"},{"doc":"","ref":"StripJs.html#t:html_tag/0","title":"StripJs.html_tag/0","type":"type"},{"doc":"","ref":"StripJs.html#t:html_tree/0","title":"StripJs.html_tree/0","type":"type"},{"doc":"","ref":"StripJs.html#t:opts/0","title":"StripJs.opts/0","type":"type"}]